## Linux
Supported operating systems:
* Ubuntu* 18.04 LTS Desktop 64bits
* Ubuntu* 18.04 LTS Server 64bits
* Ubuntu* 20.04 LTS Server 64bits

Requirements:
* make
* gcc
* g++
* maven
* JDK `1.8+`

Prerequisite:
* Intel(R) SGX DCAP Driver
* Intel(R) SGX SDK
* Intel(R) SGX DCAP Packages
* Intel(R) SGX DCAP PCCS (Provisioning Certificate Caching Service)

*Please refer to SGX DCAP Linux installation guide "https://download.01.org/intel-sgx/sgx-dcap/#version#/linux/docs/Intel_SGX_DCAP_Linux_SW_Installation_Guide.pdf" to install above dependencies*<br/>
*Note that you need to change **\#version\#** to actual version number in URL, such as 1.4.*

*Please make sure the config file of qcnl is configured properly

1. Generate an ECDSA quote with certification data of type 5 using QuoteGenerationSample
```
   $ cd SampleCode/QuoteGenerationSample/
   $ make
   $ ./app
```
Update environment variables
```
   $ export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:${Project_basedir}/src/main/c/lib
```
2. Build and test *JavaQuoteVerificationSample* to verify a given quote

2.1 Compile package
```
   $ mvn compile package
```
2.2 Run verify quote command, here use the demo quote in ${Project_basedir}/src/main/resources
```
   $  java -jar ./target/JavaQuoteVerificationSample-1.0.jar -q <path to quote>
```

2.2 Clean
- If you want to clean the files generated by previous `mvn compile` command, enter the following command:
```
    $ mvn clean
```

